package ru.bitel.mybgbilling.kernel.common.inject;

import java.io.Serializable;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.context.SessionScoped;
import javax.faces.view.ViewScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import ru.bitel.mybgbilling.kernel.common.AbstractBean;
import ru.bitel.mybgbilling.kernel.common.inject.BGInject;
import ru.bitel.mybgbilling.kernel.common.inject.BGInjection;

import ru.bitel.mybgbilling.kernel.contract.NotificationBean;
import ru.bitel.bgbilling.common.BGException;
import ru.bitel.bgbilling.plugins.notification.common.bean.ContractNotification;
import ru.bitel.bgbilling.kernel.contract.api.common.service.ContractNotificationService;

@Named
@ViewScoped
@BGInjection
public class MyNotificationBean
    extends AbstractBean
    implements Serializable
{
    @BGInject
    private ContractNotificationService contractNotificationService;

    private List<ContractNotification> contractNotificationList;

    @Override
    protected void init()
        throws BGException
    {
        populate();
    }

    public void populate()
        throws BGException
    {
        contractNotificationList = contractNotificationService.contractNotificationList( getContractId() );
    }

    public List<ContractNotification> getContractNotificationList()
    {
        return contractNotificationList;
    }
    
    public void markRead( int id )
        throws BGException
    {
        contractNotificationService.contractNotificationMarkRead( getContractId(), id );

        populate();
    }

    public void deleteContractNotification( int id )
        throws BGException
    {
        contractNotificationService.contractNotificationDelete( getContractId(), id );

        populate();
    }
}